=== debian/changelog ===
btop (1.2.3-2) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * debian/rules: Remove embedded build paths by passing -ffile-prefix-map
    via ADDFLAGS variable. (closes: #1005792)

 -- Marius Gripsgard <marius@ubports.com>  Sun, 20 Feb 2022 21:08:26 +0100

btop (1.2.3-1) unstable; urgency=medium

  * New upstream release v1.2.3

 -- Marius Gripsgard <marius@ubports.com>  Sun, 20 Feb 2022 20:19:43 +0100

btop (1.2.2-1) unstable; urgency=medium

  * New upstream release v1.2.2
  * debian/control:
     - Add Vcs pointing to our salsa repo
     - Only build for linux based arches
  * debian/copyright: Add new files added upstream
  * debian/patches: Remove upstreamed patch:
    - 0001-Fix-spelling-mistakes-caught-by-debian-lintian.patch

 -- Marius Gripsgard <marius@ubports.com>  Mon, 14 Feb 2022 23:32:20 +0100

btop (1.1.3-1) unstable; urgency=medium

  * Initial release. Closes: #1001633

 -- Marius Gripsgard <marius@ubports.com>  Mon, 13 Dec 2021 13:16:11 +0100
