## btop 1.2.7

=== debian/changelog ===
btop (1.2.7-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports, no change.

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 20 Jun 2022 10:55:17 -0400

btop (1.2.7-1) unstable; urgency=medium

  * New upstream release v1.2.7

 -- Marius Gripsgard <marius@ubports.com>  Wed, 01 Jun 2022 01:17:58 +0200

btop (1.2.6-1) unstable; urgency=medium

  * New upstrem release v1.2.6

 -- Marius Gripsgard <marius@ubports.com>  Sun, 17 Apr 2022 01:10:38 +0200

btop (1.2.5-1) unstable; urgency=medium

  * New upstream release v1.2.5

 -- Marius Gripsgard <marius@ubports.com>  Sun, 06 Mar 2022 19:50:56 +0100

btop (1.2.4-1) unstable; urgency=medium

  * New upstream release v1.2.4

 -- Marius Gripsgard <marius@ubports.com>  Mon, 28 Feb 2022 10:10:32 +0100
