=== debian/changelog ===
btop (1.2.13-1) unstable; urgency=medium

  * New upstream release v1.2.13

 -- Marius Gripsgard <marius@ubports.com>  Mon, 07 Nov 2022 01:12:16 +0100

btop (1.2.12-1) unstable; urgency=medium

  * New upstream release v1.2.12
  * Refresh copyright file to mach new upstream release
  * Bump standards-version to 4.6.1

 -- Marius Gripsgard <marius@ubports.com>  Sat, 29 Oct 2022 01:34:09 +0200
