=== debian/changelog ===
btop (1.3.0-1) unstable; urgency=medium

  * New upstream release v1.3.0
  * debian/control: Use my debian email
  * debian/control: Bump standards-version
  * debian/copyright: refresh copyright

 -- Marius Gripsgard <mariogrip@debian.org>  Sat, 27 Jan 2024 02:30:00 +0100
