=== debian/changelog ===
btop (1.3.2-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bug fixes release from upstream. (Closes: #1100022, #1100542)

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Tue, 06 May 2025 12:12:58 +0200
