=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 export ADDFLAGS = -ffile-prefix-map=$(CURDIR)=.
 
 %:
-	dh $@
+	dh $@ -- 
 
 override_dh_auto_install:
 	dh_auto_install -- DESTDIR=$(CURDIR)/debian/btop PREFIX=/usr
